SystemOrganization addCategory: 'JASVGI-Graphics'!

JASVGICanvas subclass: #JASVGIGraphCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Graphics'!

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 11:16'!
example1
 | dict |

	dict := Dictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawBarGraph: dict at: 10@200 maxHeight: 180 width: 30)
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 12:06'!
example2
 | dict |

	dict := Dictionary new.
	dict at: 'rusia' put: 30;
		at: 'usa' put: 25;
		at: 'china' put: 20;
		at: 'india' put: 20;
		at: 'vietnam' put: 5.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPiesDesc: dict at: 120@120 zoom: 1) contents! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 11:47'!
colorPalette

	^#('ALICEBLUE' 'BEIGE' 'BROWN' 'BURLYWOOD' 'DARKCYAN' 'DARKGRAY' 'DARKSALMON' 'GOLD' 'GOLDENROD' 'GRAY' 'LIGHTBLUE' 'LIGHTSLATEGRAY' 'SEAGREEN' 'SLATEGRAY' 'TOMATO')! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 10:16'!
drawBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width 
	| lateralIndex x y maxValue axis yShift |

	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x + 25.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height:10).
	axis := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y -  maxHeight - 20)).
	axis setMarkerEnd: 'arrow'. 
	yShift := maxHeight // 5.
	1 to: 5 do: [:index | | axisRange |
		axisRange := y - (yShift * index).
		self drawLineFrom: ((aPoint x - 5) @ axisRange) to: ((aPoint x + 5) @ axisRange).
		self drawText: ((maxValue * index // 5) - 5) printString at: ((aPoint x - 10) @ (axisRange - 3))]. 

	"draw rectangle bars"
	aDictionary keysAndValuesDo: [:key :value | | text graph graphHeight |
		text := self drawText: key at: x @ y textSizePx: '10px'.
		graphHeight := value * maxHeight //  maxValue.
		graph := self drawRectangleAt: (x @ (y - 10 - graphHeight)) height: graphHeight width: width fillColor: self colorPalette randomPeek stroke: 'black'.
		lateralIndex := lateralIndex + 1.
		x := x + width + 10.
	].! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 12:18'!
drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom 

	^self drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom showTotal: true! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 12:18'!
drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom showTotal: showTotal
	| xShift yText prevRadius switch |

	yText := aPoint y.
	switch := true.

	showTotal 
	ifTrue: [
		self drawCircleAt: aPoint r: (100 * zoom) fillColor: self colorPalette randomPeek stroke: 'black'.
		self drawText: 'Total - 100%' at: aPoint.
		prevRadius := (100 * zoom).
		xShift := aPoint x + prevRadius]
	ifFalse: [xShift := aPoint x].

	(aBoolean ifTrue: [collectionPercentage asSortedCollection] ifFalse: [collectionPercentage asSortedCollection reverse])
		do: [:eachValue | | key radius |
			yText := switch ifTrue: [aPoint y + 10] ifFalse: [aPoint y - 10].
			key := collectionPercentage keyAtValue: eachValue.
			radius := eachValue * zoom.
			xShift := xShift + radius + 10.
			self drawCircleAt: (xShift @ aPoint y) r: radius fillColor: self colorPalette randomPeek stroke: 'black'.
			self drawText: (key, ' ', eachValue printString, '%') at: ((xShift - radius + 10) @ yText).
			prevRadius := radius.
			xShift := xShift + prevRadius + 10.
			switch := switch not.
		].! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 12:05'!
drawPiesAsc: collectionPercentage at: aPoint zoom: zoom

	^self drawPies: collectionPercentage at: aPoint asc: true zoom: zoom! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 12:19'!
drawPiesAsc: collectionPercentage at: aPoint zoom: zoom showTotal: aBoolean

	^self drawPies: collectionPercentage at: aPoint asc: true zoom: zoom showTotal: aBoolean! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 12:05'!
drawPiesDesc: collectionPercentage at: aPoint zoom: zoom

	^self drawPies: collectionPercentage at: aPoint asc: false zoom: zoom! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/18/2016 12:20'!
drawPiesDesc: collectionPercentage at: aPoint zoom: zoom showTotal: aBoolean

	^self drawPies: collectionPercentage at: aPoint asc: false zoom: zoom showTotal: aBoolean! !
